package dareka.processor;

import java.io.IOException;
import java.util.regex.Pattern;

public interface Processor {
    /**
     * T|[gĂ郁\bh₢킹鎞ɃVXeĂяo܂B
     * GETPOSTȂǁAT|[gĂ郁\bhzŕԂĂB
     * 
     * @return T|[gĂ郁\bh񋓂zB
     */
    String[] getSupportedMethods();
    
    /**
     * T|[gĂURL₢킹鎞ɃVXeĂяo܂B
     * T|[gĂURLɃ}b`鐳K\ԂĂB
     * 
     * @return T|[gĂURLɃ}b`鐳K\B
     * nullԂꍇ͑getSupportedURLAsString()ĂяoB
     */
    Pattern getSupportedURLAsPattern();
    
    /**
     * T|[gĂURL₢킹鎞ɃVXeĂяo܂B
     * T|[gĂURL߂lŎĂB
     * 擪߂l̕Ŏn܂ĂURLɃ}b`܂B
     * K\svȊȈՔŁB
     * 
     * @return T|[gĂURLB
     * getSupportedURLAsPattern()łłnullԂꍇ͑SĂURLɃ}b`B
     */
    String getSupportedURLAsString();
    
    /**
     * T|[gĂ郁\bhURLɍvNGXg
     * CoEh(uEU)瓞
     * VXeĂяo܂B
     * X|Xǂ̃\[X擾邩肵A
     * ߂lŎĂB
     * 
     * @param requestHeader NGXg̃wb_B
     * CƁAAEgoEh(T[o)ɑMwb_
     * fB
     * @return X|XƂĕԂ\[XB
     * @throws IOException 
     */
    Resource onRequest(HttpRequestHeader requestHeader) throws IOException;
}
